diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index 916f30673..8633176a8 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -16,17 +16,17 @@ public class PlayerControllerSP extends PlayerController {
 	@Override
 	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
 		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
-		int id = mc.theWorld.getBlockId(x, y, z);
-		int meta = mc.theWorld.getBlockMetadata(x, y, z);
-		TileEntity tileEntity = mc.theWorld.getBlockEntity(x, y, z);
+		int id = mc.currentWorld.getBlockId(x, y, z);
+		int meta = mc.currentWorld.getBlockMetadata(x, y, z);
+		TileEntity tileEntity = mc.currentWorld.getBlockEntity(x, y, z);
 		boolean removed = super.destroyBlock(x, y, z, side, player);
 		ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 
 		if (item != null) {
-			item.onDestroyBlock(mc.theWorld, id, x, y, z, side, mc.thePlayer);
+			item.onDestroyBlock(mc.currentWorld, id, x, y, z, side, mc.thePlayer);
 		}
 		if (removed && mc.thePlayer.getGamemode().dropBlockOnBreak()) {
-			Block.blocksList[id].harvestBlock(mc.theWorld, mc.thePlayer, x, y, z, meta, tileEntity);
+			Block.blocksList[id].harvestBlock(mc.currentWorld, mc.thePlayer, x, y, z, meta, tileEntity);
 		}
 
 		if (item != null && item.stackSize <= 0)
diff --git a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index bffcb24ef..6b807c251 100644
--- a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -27,7 +27,7 @@ import net.minecraft.core.entity.projectile.ProjectileCannonball;
 import net.minecraft.core.entity.projectile.ProjectileEgg;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
-import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.Items;
 import org.lwjgl.opengl.GL11;
 import net.minecraft.client.option.GameSettings;
@@ -123,7 +123,7 @@ public class EntityRenderDispatcher
         renderers.put(EntityPrimedTNT.class, new EntityRendererTNT());
         renderers.put(EntityFallingBlock.class, new EntityRendererFallingBlock());
         renderers.put(MinecartEntity.class, new EntityRendererMinecart());
-        renderers.put(BoatEntity.class, new EntityRendererBoat());
+        renderers.put(EntityBoat.class, new EntityRendererBoat());
         renderers.put(EntityFishingBobber.class, new EntityRendererFishingBobber());
         renderers.put(MobFireflyCluster.class, new MobRendererFireflyCluster());
         renderers.put(EntityLightning.class, new EntityRendererLightningBolt());
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index b0d8db120..df504172f 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -4,6 +4,7 @@ import static org.lwjgl.opengl.GL11.*;
 
 import java.nio.FloatBuffer;
 
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.opengl.NVFogDistance;
 
@@ -41,10 +42,10 @@ public class FogManager {
     public void updateBrightness() {
         fogBrightnessOld = fogBrightness;
 
-        float fogModifier = mc.theWorld.getCurrentWeather() != null ? mc.theWorld.getCurrentWeather().fogDistance : 1.0f;
-        fogModifier = (1.0f - ((1.0f - fogModifier) * mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherPower()));
+        float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().fogDistance : 1.0f;
+        fogModifier = (1.0f - ((1.0f - fogModifier) * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower()));
 
-        float brightnessAtCamera = mc.theWorld.getLightBrightness(MathHelper.floor(mc.activeCamera.getX(1f)), MathHelper.floor(mc.activeCamera.getY(1f)), MathHelper.floor(mc.activeCamera.getZ(1f)));
+        float brightnessAtCamera = mc.currentWorld.getLightBrightness(MathHelper.floor(mc.activeCamera.getX(1f)), MathHelper.floor(mc.activeCamera.getY(1f)), MathHelper.floor(mc.activeCamera.getZ(1f)));
         if (mc.fullbright) brightnessAtCamera = 1.0f;
         float renderDistanceModifier = (((mc.gameSettings.renderDistance.highest - mc.gameSettings.renderDistance.value) * fogModifier) / (float) mc.gameSettings.renderDistance.highest);
 
@@ -58,12 +59,12 @@ public class FogManager {
         glFogfv(GL_FOG_COLOR, buffer(fogRed, fogGreen, fogBlue, 0.5F));
         glNormal3f(0.0F, -1F, 0.0F);
         glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.theWorld, Material.water, partialTick))
+        if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.water, partialTick))
         {
             glFogi(GL_FOG_MODE, GL_EXP);
             glFogf(GL_FOG_DENSITY, 0.1F);
         }
-        else if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.theWorld, Material.lava, partialTick))
+        else if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.lava, partialTick))
         {
             glFogi(GL_FOG_MODE, GL_EXP);
             glFogf(GL_FOG_DENSITY, 2.0F);
@@ -73,8 +74,8 @@ public class FogManager {
             float maxFogDistance = RenderDistance.EXTREME.chunks * 16;
             float fogDistance = farPlaneDistance;
 
-            float fogModifier = mc.theWorld.getCurrentWeather() != null ? mc.theWorld.getCurrentWeather().fogDistance : 1.0f;
-            fogModifier = (1.0f - ((1.0f - fogModifier) * mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherPower()));
+            float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().fogDistance : 1.0f;
+            fogModifier = (1.0f - ((1.0f - fogModifier) * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower()));
 
             if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
 
@@ -96,7 +97,7 @@ public class FogManager {
             {
                 glFogi(NVFogDistance.GL_FOG_DISTANCE_MODE_NV, NVFogDistance.GL_EYE_RADIAL_NV);
             }
-            if(mc.theWorld.dimension == Dimension.NETHER)
+            if(mc.currentWorld.dimension == Dimension.NETHER)
             {
                 glFogf(GL_FOG_START, 0.0F);
             }
@@ -107,7 +108,7 @@ public class FogManager {
 
     public void updateFogColor(float partialTick)
     {
-        World world = mc.theWorld;
+        WorldClient world = mc.currentWorld;
 
         float renderDistanceScale = 1.0F / (float)((mc.gameSettings.renderDistance.highest + 1) - mc.gameSettings.renderDistance.value);
         renderDistanceScale = 1.0F - (float) Math.pow(renderDistanceScale, 0.25D);
diff --git a/src/main/java/net/minecraft/client/render/Font.java b/src/main/java/net/minecraft/client/render/Font.java
index 9e8c28c82..22dd70342 100644
--- a/src/main/java/net/minecraft/client/render/Font.java
+++ b/src/main/java/net/minecraft/client/render/Font.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.lang.text.Text;
+import net.minecraft.core.lang.text.Text;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index bc65e5e3b..b67cbc085 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -86,7 +86,7 @@ public class ItemRenderer
         	}else if(mc.fullbright) {
         		
         	}else {
-        		brightness = mc.theWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
+        		brightness = mc.currentWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
         	}
             GL11.glColor4f(brightness, brightness, brightness, 1.0f);
             EntityRenderer<? extends Entity> render = EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
@@ -143,11 +143,11 @@ public class ItemRenderer
 
             TextureRegistry.blockAtlas.bind();
 			
-			int id = mc.theWorld.getBlockId(blockX, blockY, blockZ);
-            int meta = mc.theWorld.getBlockMetadata(blockX, blockY, blockZ);
+			int id = mc.currentWorld.getBlockId(blockX, blockY, blockZ);
+            int meta = mc.currentWorld.getBlockMetadata(blockX, blockY, blockZ);
             Block block = Block.blocksList[id];
             BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
-			if(mc.theWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
+			if(mc.currentWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
 				renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
 			} else {
                 id = 0;
@@ -160,9 +160,9 @@ public class ItemRenderer
 					int y1 = MathHelper.floor_float(blockY + y0);
 					int z1 = MathHelper.floor_float(blockZ + z0);
 					
-					if(mc.theWorld.isBlockNormalCube(x1, y1, z1)) {
-						id = mc.theWorld.getBlockId(x1, y1, z1);
-                        meta = mc.theWorld.getBlockMetadata(x1, y1, z1);
+					if(mc.currentWorld.isBlockNormalCube(x1, y1, z1)) {
+						id = mc.currentWorld.getBlockId(x1, y1, z1);
+                        meta = mc.currentWorld.getBlockMetadata(x1, y1, z1);
                         break;
 					}
 				}
diff --git a/src/main/java/net/minecraft/client/render/LightmapHelper.java b/src/main/java/net/minecraft/client/render/LightmapHelper.java
index 2b529a91b..620ce591d 100644
--- a/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -43,7 +43,7 @@ public class LightmapHelper {
 	}
 	
 	public void setup() {
-		World world = mc.theWorld;
+		World world = mc.currentWorld;
 		if(mc.gameSettings.customLightmap.value && world != null) {
 			int dimension = world.dimension.id;
 			
@@ -71,7 +71,7 @@ public class LightmapHelper {
 	}
 	
 	public void tick() {
-		World world = mc.theWorld;
+		World world = mc.currentWorld;
 		if(world == null) {
 			return;
 		}
@@ -88,7 +88,7 @@ public class LightmapHelper {
 	}
 
 	public void update(float partialTicks) {
-		World world = mc.theWorld;
+		World world = mc.currentWorld;
 
 		if(!isEnabled() || world == null) {
 			return;
diff --git a/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index 0cf87c0b1..4a464eb55 100644
--- a/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -46,15 +46,15 @@ public class PostProcessingManager
 
     public void update()
     {
-        if (mc.theWorld == null || mc.thePlayer == null) return;
+        if (mc.currentWorld == null || mc.thePlayer == null) return;
 
         reset();
         if (mc.gameSettings.colorCorrection.value == 0) return;
 
         float surfaceness = 1.0f;
         float y = (float)mc.thePlayer.y;
-        int maxY = mc.theWorld.getWorldType().getMaxY();
-        int minY = mc.theWorld.getWorldType().getMinY();
+        int maxY = mc.currentWorld.getWorldType().getMaxY();
+        int minY = mc.currentWorld.getWorldType().getMinY();
         int rangeY = maxY - minY;
         int halfY = minY + rangeY / 2;
         int quarterY = minY + rangeY / 4;
@@ -64,15 +64,15 @@ public class PostProcessingManager
         surfaceness = adjustedY / hToQRange;
         surfaceness = MathHelper.clamp(surfaceness, 0.0f, 1.0f);
 
-        double temperature = mc.theWorld.getBlockTemperature((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
+        double temperature = mc.currentWorld.getBlockTemperature((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
         if (temperature == Double.NEGATIVE_INFINITY) temperature = lastTemperature;
         lastTemperature = temperature;
-        double humidity = mc.theWorld.getBlockHumidity((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
+        double humidity = mc.currentWorld.getBlockHumidity((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
         if (humidity == Double.NEGATIVE_INFINITY) humidity = lastHumidity;
         lastHumidity = humidity;
 
         // Perform base temperature change
-        if (mc.theWorld.dimension == Dimension.OVERWORLD)
+        if (mc.currentWorld.dimension == Dimension.OVERWORLD)
         {
             lastTemperature = temperature;
             temperature = (temperature * 2) - 1.0; // Ranges from -1.0 to 1.0
@@ -81,35 +81,35 @@ public class PostProcessingManager
         }
 
         // Perform season effects
-        float seasonProgress = mc.theWorld.getSeasonManager().getSeasonProgress(); // Ranges from 0.0 to 1.0
+        float seasonProgress = mc.currentWorld.getSeasonManager().getSeasonProgress(); // Ranges from 0.0 to 1.0
         seasonProgress = (seasonProgress * 2) - 1f; // Ranges from -1.0 to 1.0
         seasonProgress = Math.abs(seasonProgress); // Ranges from 1.0 to 0.0 to 1.0
         seasonProgress = -seasonProgress + 1.0f; // Ranges from 0.0 to 1.0 to 0.0
-        if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING)
+        if (mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING)
         {
             saturation += 0.1f * seasonProgress * surfaceness;
         }
-        else if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER)
+        else if (mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER)
         {
             rMod += 0.1f * seasonProgress * surfaceness;
             gMod += 0.1f * seasonProgress * surfaceness;
         }
-        else if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)
+        else if (mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)
         {
             contrast -= 0.1f * seasonProgress * surfaceness;
             rMod += 0.1f * seasonProgress * surfaceness;
         }
-        else if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER)
+        else if (mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER)
         {
             contrast -= 0.1f * seasonProgress * surfaceness;
             bMod += 0.1f * seasonProgress * surfaceness;
         }
 
         // Perform weather effects
-        Weather activeWeather = mc.theWorld.getCurrentWeather();
+        Weather activeWeather = mc.currentWorld.getCurrentWeather();
         if (activeWeather != null)
         {
-            float intensity = mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherIntensity();
+            float intensity = mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherIntensity();
             if (activeWeather == Weathers.OVERWORLD_SNOW || activeWeather == Weathers.OVERWORLD_WINTER_SNOW)
             {
                 contrast += -0.125f * intensity * surfaceness;
@@ -143,7 +143,7 @@ public class PostProcessingManager
         }
 
         // Perform dimension effects
-        if (mc.theWorld.getWorldType() == WorldTypes.NETHER_DEFAULT || mc.theWorld.getWorldType() == WorldTypes.OVERWORLD_HELL)
+        if (mc.currentWorld.getWorldType() == WorldTypes.NETHER_DEFAULT || mc.currentWorld.getWorldType() == WorldTypes.OVERWORLD_HELL)
         {
             rMod += 1.2f;
             gMod += 0.3f;
@@ -155,7 +155,7 @@ public class PostProcessingManager
         }
 
         // Perform heatwave effects
-        if (mc.theWorld.dimension == Dimension.OVERWORLD && (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL))
+        if (mc.currentWorld.dimension == Dimension.OVERWORLD && (mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL))
         {
             if (temperature >= 0.85 && humidity <= 0.15)
             {
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index c4904019e..0f623c0a3 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -17,11 +17,13 @@ import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.worldtype.WorldTypeFX;
+import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemDiscMusic;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
@@ -53,21 +55,6 @@ import java.util.Random;
 
 import static org.lwjgl.opengl.GL11.*;
 
-// Referenced classes of package net.minecraft.src:
-//            IWorldAccess, GLAllocation, RenderList, OpenGlCapsChecker, 
-//            Tessellator, World, RenderManager, RenderBlocks,
-//            Block, GameSettings, BlockLeaves, WorldRenderer, 
-//            Entity, MathHelper, EntitySorter, TileEntityRenderer,
-//            ICamera, Mob, TileEntity, RenderHelper,
-//            EntityRenderer, WorldProvider, Vec3D, RenderEngine, 
-//            RenderSorter, MovingObjectPosition, Player, EnumMovingObjectType,
-//            AxisAlignedBB, GuiIngame, SoundEngine, EntityBubbleFX,
-//            EffectRenderer, EntitySmokeFX, EntityNoteFX, EntityPortalFX, 
-//            EntityExplodeFX, EntityFlameFX, EntityLavaFX, EntityFootStepFX, 
-//            EntitySplashFX, EntityReddustFX, EntityItemFX, Item,
-//            EntitySnowShovelFX, EntityHeartFX, ImageBufferDownload, StepSound, 
-//            ItemDiscMusic, ItemStack
-
 public class RenderGlobal
     implements LevelListener
 {
@@ -199,7 +186,7 @@ public class RenderGlobal
         tessellator.draw();
     }
 
-    public void changeWorld(World world)
+    public void changeWorld(WorldClient world)
     {
         if(worldObj != null)
         {
@@ -826,7 +813,8 @@ public class RenderGlobal
 
     public void drawSky(float partialTick)
     {
-        if(!mc.theWorld.getWorldType().hasSky() || mc.currentScreen instanceof ScreenModelViewer)
+        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
+        if(!worldTypeFX.hasSky() || mc.currentScreen instanceof ScreenModelViewer)
         {
             return;
         }
@@ -847,7 +835,7 @@ public class RenderGlobal
         GL11.glEnable(GL_BLEND);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         Lighting.disable();
-        float[] sunriseColor = worldObj.worldType.getSunriseColor(celestialAngle, partialTick);
+        float[] sunriseColor = worldTypeFX.getSunriseColor(celestialAngle, partialTick);
         if(sunriseColor != null)
         {
             GL11.glDisable(GL_TEXTURE_2D);
@@ -974,8 +962,6 @@ public class RenderGlobal
             targetRainbowBrightness = 0;
         }
 
-
-
         // Render moon
         size = 20F;
         textureManager.loadTexture("/terrain/moon.png").bind();
@@ -1000,7 +986,7 @@ public class RenderGlobal
         GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glEnable(GL11.GL_FOG);
         GL11.glPopMatrix();
-        if(worldObj.worldType.hasGround())
+        if(worldTypeFX.hasGround())
         {
             GL11.glColor3f(r * 0.2F + 0.04F, g * 0.2F + 0.04F, b * 0.6F + 0.1F);
         } else
@@ -1017,7 +1003,8 @@ public class RenderGlobal
 
     public void renderClouds(float partialTick)
     {
-        if(!mc.theWorld.getWorldType().hasClouds())
+        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
+        if(!worldTypeFX.hasClouds())
         {
             return;
         }
@@ -1049,7 +1036,7 @@ public class RenderGlobal
         int k = MathHelper.floor(posZ / 2048D);
         posX -= j * 2048;
         posZ -= k * 2048;
-        float cloudHeight = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
+        float cloudHeight = (worldTypeFX.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
         float f10 = (float)(posX * (double)f6);
         float f11 = (float)(posZ * (double)f6);
         tessellator.startDrawingQuads();
@@ -1074,10 +1061,11 @@ public class RenderGlobal
 
     public void renderCloudsFancy(float partialTick)
     {
+        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
     	mc.renderer.beginRenderClouds(partialTick);
     	
         float celestialAngle = worldObj.getCelestialAngle(partialTick);
-        float[] sunriseColor = worldObj.worldType.getSunriseColor(celestialAngle, partialTick);
+        float[] sunriseColor = worldTypeFX.getSunriseColor(celestialAngle, partialTick);
         float rSun = 0.0f, gSun = 0.0f, bSun = 0.0f, aSun = 0.0f;
         if (sunriseColor != null) {
             rSun = sunriseColor[0];
@@ -1098,7 +1086,7 @@ public class RenderGlobal
         float cloudThickness = 4F;
         double dx = (mc.activeCamera.getX(partialTick) + (double)((lastCloudOffsetX + (cloudOffsetX - lastCloudOffsetX) * partialTick) * 0.03F)) / (double)cloudWidth;
         double dz = (mc.activeCamera.getZ(partialTick) + (double)((lastCloudOffsetZ + (cloudOffsetZ - lastCloudOffsetZ) * partialTick) * 0.03F)) / (double)cloudWidth + 0.33D;
-        float dy = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
+        float dy = (worldTypeFX.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
         int i = MathHelper.floor(dx / 2048D);
         int j = MathHelper.floor(dz / 2048D);
         dx -= i * 2048;
@@ -1457,7 +1445,7 @@ public class RenderGlobal
 		int x1 = x0 + 16;
 		int z1 = z0 + 16;
 		
-		int worldHeight = mc.theWorld.getHeightBlocks();
+		int worldHeight = mc.currentWorld.getHeightBlocks();
 
 		glLineWidth(2.0f);
         glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
@@ -1793,7 +1781,7 @@ public class RenderGlobal
 	}
 
     public List<TileEntity> tileEntities;
-    private World worldObj;
+    private WorldClient worldObj;
     private final TextureManager textureManager;
     private final List<ChunkRenderer> chunkRenderersToUpdate;
     private ChunkRenderer[] sortedChunkRenderers;
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 323896785..4e3219d1e 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -6,6 +6,7 @@ import java.util.List;
 import java.util.Random;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.input.Mouse;
@@ -32,7 +33,7 @@ import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.culling.Frustum;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.util.debug.Debug;
+import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
@@ -120,7 +121,7 @@ public class WorldRenderer
 		if(mc.activeCamera == null) {
 			return;
 		}
-		if(mc.theWorld == null) {
+		if(mc.currentWorld == null) {
 			return;
 		}
 		
@@ -132,7 +133,7 @@ public class WorldRenderer
 		Vec3 pos2 = pos1.add(look.x * blockReach, look.y * blockReach, look.z * blockReach);
 		
 		// Raytrace blocks
-		mc.objectMouseOver = mc.theWorld.checkBlockCollisionBetweenPoints(pos1, pos2);
+		mc.objectMouseOver = mc.currentWorld.checkBlockCollisionBetweenPoints(pos1, pos2);
 		
 		// Calculate again because block raytrace changes the values
 		pos1 = mc.thePlayer.getPosition(partialTicks, false);
@@ -148,7 +149,7 @@ public class WorldRenderer
 		float expand = 1.0f;
 		AABB entitySearchBox = mc.thePlayer.bb.expand(look.x * entityReach, look.y * entityReach, look.z * entityReach).grow(expand, expand, expand);
 		
-		List<Entity> entities = mc.theWorld.getEntitiesWithinAABBExcludingEntity(mc.thePlayer, entitySearchBox);
+		List<Entity> entities = mc.currentWorld.getEntitiesWithinAABBExcludingEntity(mc.thePlayer, entitySearchBox);
 		
 		// Search for the closest hit entity
 		double pointedEntityDistance = 0.0;
@@ -203,7 +204,7 @@ public class WorldRenderer
             f1 = (int)(mc.activeCamera.getFov() * 100 + 30);
             f1 *= a + (b - a) * partialTick;
         }
-        if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.theWorld, Material.water, partialTick))
+        if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.water, partialTick))
         {
             f1 = f1 - 10;
         }
@@ -503,7 +504,7 @@ public class WorldRenderer
         }
         if (c <= 0) c = 1;
         glViewport(0, 0, mc.gameWindow.getWidthPixels(), mc.gameWindow.getHeightPixels());
-        if(mc.theWorld != null)
+        if(mc.currentWorld != null)
         {
             Debug.change("world");
             if(!mc.gameSettings.enableVsync.value && mc.gameSettings.customFpsLimit.value == 0) // Max FPS
@@ -608,7 +609,7 @@ public class WorldRenderer
         {
             double viewEntityX = activeEntity.xo + (activeEntity.x - activeEntity.xo) * (double)partialTicks;
             double viewEntityZ = activeEntity.zo + (activeEntity.z - activeEntity.zo) * (double)partialTicks;
-            IChunkProvider iChunkProvider = mc.theWorld.getChunkProvider();
+            IChunkProvider iChunkProvider = mc.currentWorld.getChunkProvider();
             int chunkX = MathHelper.floor_float((int)viewEntityX) >> 4;
             int chunkZ = MathHelper.floor_float((int)viewEntityZ) >> 4;
             iChunkProvider.setCurrentChunkOver(chunkX, chunkZ);
@@ -642,7 +643,7 @@ public class WorldRenderer
         mc.renderGlobal.clipRenderersByFrustum(mc.activeCamera.getFrustum(), partialTicks);
 
         Debug.change("aurora");
-        if (mc.gameSettings.aurora.value && mc.theWorld.getWorldType().hasAurora())
+        if (mc.gameSettings.aurora.value && WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType()).hasAurora())
         {
             renderGlobal.renderAurora(mc.activeCamera, partialTicks);
         }
@@ -758,10 +759,10 @@ public class WorldRenderer
 
     private void addRainParticles()
     {
-        Weather weather = mc.theWorld.getCurrentWeather();
+        Weather weather = mc.currentWorld.getCurrentWeather();
         if (weather == null || !weather.spawnRainParticles) return;
         
-        float f = mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherPower();
+        float f = mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower();
         
         if(mc.gameSettings.fancyGraphics.value != 1)
         {
@@ -772,7 +773,7 @@ public class WorldRenderer
             return;
         }
         random.setSeed((long)rendererUpdateCount * 0x12a7ce5fL);
-        World world = mc.theWorld;
+        World world = mc.currentWorld;
         int cameraX = MathHelper.floor(mc.activeCamera.getX());
         int cameraY = MathHelper.floor(mc.activeCamera.getY());
         int cameraZ = MathHelper.floor(mc.activeCamera.getZ());
@@ -824,20 +825,20 @@ public class WorldRenderer
             rainSoundCounter = 0;
             if(d1 > mc.activeCamera.getY() + 1.0D && world.getHeightValue(MathHelper.floor(mc.activeCamera.getX()), MathHelper.floor(mc.activeCamera.getZ())) > MathHelper.floor(mc.activeCamera.getY()))
             {
-                mc.theWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.1F * mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherPower() * 0.5f, 0.5F);
+                mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.1F * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower() * 0.5f, 0.5F);
             } else
             {
-                mc.theWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.2F * mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherPower() * 0.5f, 1.0F);
+                mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.2F * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower() * 0.5f, 1.0F);
             }
         }
     }
 
     protected void renderRainSnow(float partialTick)
     {
-        Weather weather = mc.theWorld.getCurrentWeather();
+        Weather weather = mc.currentWorld.getCurrentWeather();
         if (weather == null || !weather.isPrecipitation) return;
         
-        World world = mc.theWorld;
+        World world = mc.currentWorld;
         int posX = MathHelper.floor(mc.activeCamera.getX());
         int posY = MathHelper.floor(mc.activeCamera.getY());
         int posZ = MathHelper.floor(mc.activeCamera.getZ());
